#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define __USE_GNU
#include <regex.h>

int main( int argc, char *argv[] ) {
#define SIZE 80
   char buf[ SIZE ] = "123,4567,898709",
        pattern[ SIZE ] = "^([^,]*),([^,]*),([^,]*)$";
   if( argc > 1 ) strncpy( pattern, argv[ 1 ], SIZE - 1 );      
   struct re_pattern_buffer *weight;
   weight = (struct re_pattern_buffer*)malloc( sizeof( struct re_pattern_buffer ) );
   if( !weight ) {
      printf( "allocate error %m\n" );    
      return 1;
   }
   re_set_syntax( RE_BACKSLASH_ESCAPE_IN_LISTS | RE_CHAR_CLASSES |
	          RE_NO_BK_BRACES | RE_NO_BK_PARENS | RE_NO_BK_VBAR | RE_INTERVALS );
   const char *err = re_compile_pattern( pattern, strlen( pattern ), weight );
   if( err ) {
      printf( "compile error: %s\n", err );
      free( weight );
      return 2;
   }
   struct re_registers regs;
   memset( &regs, 0, sizeof( regs ) );
   while( fgets( buf, sizeof( buf ) - 1, stdin ) ) {
      if( buf[ strlen( buf ) - 1 ] == '\n') buf[ strlen( buf ) - 1 ] = '\0';
      if( 0 == strlen( buf ) ) continue;
      printf( "'%s' ->\n", buf ); 
      int p = re_match( weight, buf, strlen( buf ), 0, &regs );
      if( p <= 0 ) { 
         printf( "no match\n" );
         continue;
      }
      for( int c = 0; ( c < p ) && ( regs.start[ c ] >= 0 ); c++ ) {
         printf( "%d/%d : ", regs.start[ c ], regs.end[ c ] );
         for( int i = regs.start[ c ]; i < regs.end[ c ]; i++ )
            printf( "%c", buf[ i ] );
         printf( "\n" );
      }
   }
   free( weight );
   return 0;
}
