#include <stdio.h>
#include <string.h>
#include <locale.h>
#include <pcre.h>

// http://www.opennet.ru/base/dev/pcre_cpp.txt.html

/*
int pcre_exec(const pcre *code, const pcre_extra *extra,
            const char *subject, int length, int startoffset,
            int options, int *ovector, int ovecsize);
*/

int main( int argc, char *argv[] ) {
#define SIZE 80
   char buf[ SIZE ] = "test test test test ", // errbuf[ SIZE ] = "",
        pattern[ SIZE ] = "s";      
#define MATCHSIZE 20
   const unsigned char *locale_tables = pcre_maketables();
   if( argc > 1 ) strncpy( pattern, argv[ 1 ], SIZE - 1 );
   int options = 0;
   const char *error;
   int erroffset;
   pcre *re = pcre_compile( (char*)pattern, options, &error, &erroffset, locale_tables );
//   pcre *re  =  pcre_compile ((char *) pattern, options, &error, &erroffset, NULL);
   if( !re ) {
      printf( "pattern error: %s\n", error );
      return 1;
   }
   int count = 0;
   int ovector[ MATCHSIZE * 2 ];
   while( fgets( buf, sizeof( buf ) - 1, stdin ) ) {
      if( buf[ strlen( buf ) - 1 ] == '\n') buf[ strlen( buf ) - 1 ] = '\0';
      if( 0 == strlen( buf ) ) continue;
      printf( "'%s' ->\n", buf ); 
      count  =  pcre_exec( re, NULL, (char*)buf, strlen( buf ), 0, 0, ovector, MATCHSIZE );
      if( count < 0 ) {
         printf( "no match\n" );
         continue;
      }
      for( int c = 0; ( c < 2 * count ) && ( ovector[ c ] >= 0 ); c += 2 ) {
         printf( "%d/%d : ", ovector[ c ], ovector[ c + 1 ] );
         for( int i = ovector[ c ]; i < ovector[ c + 1 ]; i++ ) 
            printf( "%c", buf[ i ] );
         printf( "\n" );    
      }
   }      
   return 0;
}
